import type { _NSCopying } from "../Foundation/NSCopying.js";
import type { _NSObject } from "../Foundation/NSObject.js";
import type { _NSSecureCoding } from "../Foundation/NSSecureCoding.js";
import type { _VNVector } from "./VNVector.js";
import type { CGPoint } from "../structs/CGPoint.js";
export declare class _VNPoint extends _NSObject {
    static alloc(): _VNPoint;
    static new(): _VNPoint;
    init(): _VNPoint;
    /**
     * @brief Returns a new VNPoint object that is shifted by X and Y offsets of the vector. @param vector The vector offset to be applied to a source point. @param point The source point. @return the translated point.
     */
    static pointByApplyingVector$toPoint$(vector: _VNVector, point: _VNPoint): _VNPoint;
    /**
     * @brief Returns the Euclidean distance between two VNPoint objects.
     * @deprecated -distanceToPoint:
     */
    static distanceBetweenPoint$point$(point1: _VNPoint, point2: _VNPoint): number;
    /** @brief Returns a VNPoint object that represents the location of (0.0, 0.0). */
    static zeroPoint(): _VNPoint;
    /**
     * @brief Returns the Euclidean distance to another point. @param point The destination point. @return the Euclidean distance between the target and specified points.
     */
    distanceToPoint$(point: _VNPoint): number;
    /** @brief Initializes a VNPoint object from X and Y coordinates. */
    initWithX$y$(x: number, y: number): _VNPoint;
    /** @brief Initializes a VNPoint object from a CGPoint. */
    initWithLocation$(location: CGPoint): _VNPoint;
    /**
     * @brief Returns the X and Y coordinates of the point, as CGPoint type, with respect to the origin of the coordinate system the point is defined in.
     */
    location(): CGPoint;
    /**
     * @brief Returns the X coordinate of the point with respect to the origin of the coordinate system the point is defined in.
     */
    x(): number;
    /**
     * @brief Returns the Y coordinate of the point with respect to the origin of the coordinate system the point is defined in.
     */
    y(): number;
}
export interface _VNPoint extends _NSCopying, _NSSecureCoding {
}
